unit AnsiStringConfg;

interface
uses Forms, SysUtils, Registry, IniFiles,Classes;


procedure InitialiseApplication;
procedure SaveSettings(AForm: TForm);

const
  AnsiConvRegistryCurrentUserAppRoot = '\Software\INNOVA Solutions\AnsiConv';

var
  FormTop, FormLeft, FormHeight, FormWidth, ServerPort: Integer;
  LastInputDirectory, LastOutputDirectory: string;

implementation

const
 CFrm='AnsiCnvForm';
 CFiles='AnsConvFiles';


procedure InitialiseApplication;
var
  RegIni: TRegistryIniFile;
  AppPath:String;

begin
  try
    AppPath:=ExtractFilePath(Application.ExeName);
    RegIni := TRegistryIniFile.Create(AnsiConvRegistryCurrentUserAppRoot);
    try
      FormTop := RegIni.ReadInteger(CFrm, 'Top', 0);
      FormLeft := RegIni.ReadInteger(CFrm, 'Left', 0);
      FormWidth := RegIni.ReadInteger(CFrm, 'Width', 0);
      FormHeight := RegIni.ReadInteger(CFrm, 'Height', 0);
      LastInputDirectory := RegIni.ReadString(CFiles, 'InputPutDir', '');
      LastOutputDirectory := RegIni.ReadString(CFiles, 'OutPutDir', '');
    finally
      RegIni.Free;
    end;
  except
    on E: Exception do
      raise Exception.Create('Error in Initialization:: ' + E.Message);
  end;
end;

procedure SaveSettings(AForm: TForm);
var
  RegIni: TRegistryIniFile;
begin
  try
    RegIni := TRegistryIniFile.Create(AnsiConvRegistryCurrentUserAppRoot);
    try
      RegIni.WriteInteger(CFrm, 'Top', AForm.Top);
      RegIni.WriteInteger(CFrm, 'Left', AForm.Left);
      RegIni.WriteInteger(CFrm, 'Width', AForm.Width);
      RegIni.WriteInteger(CFrm, 'Height', AForm.Height);
      RegIni.WriteString(CFiles, 'InputPutDir', LastInputDirectory);
      RegIni.WriteString(CFiles, 'OutPutDir', LastOutputDirectory);
    finally
      RegIni.Free;
    end;
  except
    on e: Exception do
      raise Exception.Create('Save Registry Fail::' + e.Message);
  end;
end;

end.
