unit ISDlgOpenDirectory;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl;

type
  TOpenDirectoryDlg = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    BtnOK: TButton;
    BtnCancel: TButton;
    DriveComboBox1: TDriveComboBox;
    LblDirectoryText: TLabel;
    BtnCreateNew: TButton;
    EdtNewName: TEdit;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure BtnCreateNewClick(Sender: TObject);
  private
    { Private declarations }
    FResultDirectory:AnsiString;
    FInitialDirectory: AnsiString;
    FAllowCreateNew: Boolean;
  public
    { Public declarations }
    Function Execute: Boolean;
    Function DirectoryName:AnsiString;
    Property InitialDirectory:AnsiString Read FInitialDirectory Write FInitialDirectory;
    Property AllowCreateNew:Boolean Read FAllowCreateNew write FAllowCreateNew;
  end;

implementation

{$R *.dfm}

{ TOpenDirectory }

procedure TOpenDirectoryDlg.BtnCreateNewClick(Sender: TObject);
begin
  If EdtNewName.Visible then
    Begin
      ForceDirectories(DirectoryListBox1.Directory+'\'+EdtNewName.Text);
      DirectoryListBox1.Update;
      BtnCreateNew.Visible:=false;
      EdtNewName.Visible:=false;
      BtnCreateNew.Caption:= 'New Folder';
    end
   else
    begin
      BtnCreateNew.Caption:= 'Confirm Folder';
      EdtNewName.Visible:=True;
    end;
end;

procedure TOpenDirectoryDlg.DirectoryListBox1Change(Sender: TObject);
begin
  BtnCreateNew.Visible:= FAllowCreateNew And (DirectoryListBox1.ItemIndex>-1);
end;

function TOpenDirectoryDlg.DirectoryName: AnsiString;
begin
  Result:=FResultDirectory;
end;



function TOpenDirectoryDlg.Execute: Boolean;
begin
  if FInitialDirectory<>'' then
  if DirectoryExists(FInitialDirectory) then
    DirectoryListBox1.Directory:=FInitialDirectory;
  Result:=ShowModal=mrOk;
end;

procedure TOpenDirectoryDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin

 If ModalResult=mrOk then
   begin
    if DirectoryListBox1.ItemIndex>-1 then
     Begin
       CanClose:=true;
       FResultDirectory:=DirectoryListBox1.Directory
     end
     else
    CanClose:=False
   end
   else
    Begin
    FResultDirectory:='';
    CanClose:=true;
    end;
end;

end.
